#define GAUGE1 2
#define GAUGE2 3

#define YELLOW1 5
#define YELLOW2 6
#define YELLOW3 7

#define RED1 8
#define RED2 9
#define RED3 10

#define STROBE 13

unsigned int red1Cycle=2500;
unsigned int red2Cycle=5000;
unsigned int red3Cycle=7500;

unsigned int strobeCycle=15000;


unsigned long red1LastMillis = 0;
unsigned long red2LastMillis = 0;
unsigned long red3LastMillis = 0;
unsigned long strobeLastMillis = 0;

boolean red1State = true;
boolean red2State = true;
boolean red3State = true;
boolean strobeState = true;

int i;

boolean cycleCheck( unsigned long& , unsigned int );


void setup() {
  
  pinMode(GAUGE1,OUTPUT);
  pinMode(GAUGE2,OUTPUT);
  
  pinMode(YELLOW1,OUTPUT);
  pinMode(YELLOW2,OUTPUT);
  pinMode(YELLOW3,OUTPUT);
  
  pinMode(RED1,OUTPUT);
  pinMode(RED2,OUTPUT);
  pinMode(RED3,OUTPUT);
  
  pinMode(STROBE,OUTPUT);
  
  digitalWrite(YELLOW1,HIGH);
  digitalWrite(YELLOW2,HIGH);
  digitalWrite(YELLOW3,HIGH);  
  
  digitalWrite(RED1,HIGH);
  digitalWrite(RED2,HIGH);
  digitalWrite(RED3,HIGH);
  
  digitalWrite(GAUGE1,HIGH);
  digitalWrite(GAUGE2,HIGH);
  digitalWrite(STROBE,HIGH);
  
  delay(8000);
  
  digitalWrite(YELLOW1,LOW);
  digitalWrite(YELLOW2,LOW);
  digitalWrite(YELLOW3,LOW);  
  
  digitalWrite(RED1,LOW);
  digitalWrite(RED2,LOW);
  digitalWrite(RED3,LOW);
  
  digitalWrite(GAUGE1,LOW);
  digitalWrite(GAUGE2,LOW);
  digitalWrite(STROBE,LOW);

    
}

void loop() {
  

  
    if(cycleCheck( red1LastMillis, red1Cycle)) {
      //red1Cycle = random (1500, 5000);
      digitalWrite(RED1, red1State);
      red1State = !red1State;
    }  
    if(cycleCheck( red2LastMillis, red2Cycle)) {
      //red2Cycle = random (1800, 4000);
      digitalWrite(RED2, red2State);
      red2State = !red2State;
    } 
    if(cycleCheck( red3LastMillis, red3Cycle)) {
      //red3Cycle = random (1600, 3000);
      digitalWrite(RED3, red3State);
      red3State = !red3State;
    }
    if(cycleCheck( strobeLastMillis, strobeCycle)) {
      strobeCycle = (strobeState)?30000:60000;
      digitalWrite(STROBE, strobeState);
      strobeState = !strobeState;
    }
  
    if ( red1State == LOW && red2State == LOW && red3State == LOW) 
          digitalWrite(GAUGE2,HIGH); 
    else 
          digitalWrite(GAUGE2,LOW);  
 
    if ( random(1,50) < 25 ) digitalWrite(YELLOW1,HIGH);
    if ( random(1,50) > 25 ) digitalWrite(YELLOW2,HIGH);
    
    if ( random(1,50) > 20 ) {
      
      for (i=0; i<random(1,12); i++) {
         digitalWrite(YELLOW3,HIGH);
         delay(random(250,1500));
         digitalWrite(YELLOW3,LOW); 
         delay(random(250,500));
      }
      
    }
    
    delay (random(150,1500));
    digitalWrite(YELLOW1,LOW);  
    digitalWrite(YELLOW2,LOW);
    delay (random(150,1500));
    
    if ( random(1,50) > 48 ) {
     
      for (i=0; i<5; i++) {
        digitalWrite(YELLOW1,HIGH);
        digitalWrite(GAUGE1,HIGH);
        delay(250);
        digitalWrite(YELLOW1,LOW);
        digitalWrite(GAUGE1,LOW);
        digitalWrite(YELLOW2,HIGH);
        delay(250);
        digitalWrite(YELLOW2,LOW);
        delay(250);
      }     
      
    }
  
  
}



boolean cycleCheck( unsigned long& lastMillis , unsigned int cycle) {
  
  unsigned long currentMillis = millis();
  boolean changeState = false;
  
  if (currentMillis - lastMillis >= cycle)  {
    lastMillis = currentMillis;
    changeState = true;
  }

  return changeState;

}
